## 8.2.1 (2024-11-01)

### New features

* Adds support for PETSc/SLEPc v3.22

### Breaking Changes

* The default `cfl` factor has been increased from 0.1 to 0.95. This
  is intended to avoid performance regression in 8.2.0 due to fix of
  cfl estimate for 2D. Possible that this change will require user
  intervention to reproduce old results.

### Known issues

No new known issues.

### Merged Pull Requests

* Call set_job_id as early as possible in initialize_gs2 [PR #1034 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1034)
* Bugfix/avoid potentially unused variables in ingen [PR #1035 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1035)
* Bugfix/update petsc slepc versions 3 22 1 [PR #1036 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1036)
* Minor/improve python package handling in ci [PR #1033 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1033)
* Increase the default cfl factor [PR #1030 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1030)
* Restore guidance about setting MAKEFLAGS [PR #1032 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1032)
* Set unlimted = true in glo dimension creation in cases where processor has no local data [PR #1029 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1029)
* Bugfix/correct 2d cfl limit [PR #634 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/634)
* Always initialise duinv to zero. [PR #1009 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1009)
* Write final epar to netcdf in new diagnostics [PR #1026 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1026)
* Bugfix/sort files compare response [PR #1010 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1010)
* Merge 8.2.0 into next [PR #1005 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1005)
* Make sure ford preprocesses all source files [PR #1006 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1006)

## 8.2.0 (2024-07-12)

### New features

* Much more extensive support for pure OpenMP or hybrid
  parallelisation. Pass `USE_OPENMP=on` to make in order to enable
  OpenMP.

* New operator splitting approach for nonlinear simulations. Still
  experimental but see
  [split_nonlinear_terms](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#nonlinear_terms_knobs-split_nonlinear)
  for more details.

* A (very) experimental [exponential decay boundary
  condition](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#dist_fn_knobs-exponential_boundary)
  and experimental option to put the boundary condition off of the
  grid.

* Ideal ballooning stability calculation now supports `theta0 /= 0`.

* Added a [quasi-linear metric diagnostic output](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#gs2_diagnostics_knobs-write_ql_metric).

* Ability to display a [progress
  message](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#gs2_diagnostics_knobs-write_ql_metric).

* More [timer statistics
  output](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#knobs-save_timer_statistics).

* Ability to limit the number of processors used in different data
  decompositions, such as in
  [g_lo](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#layouts_knobs-nproc_g_lo).

* Option to split both of the
  [trapped](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#le_grids_knobs-new_trap_int_split)
  and
  [passing](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#le_grids_knobs-split_passing_region)
  regions into sub-domains to help improve integration errors in some
  cases.

* Ability to turn off
  [potentials](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#nonlinear_terms_knobs-include_phi)
  in the nonlinear term only.

* [NetCDF theta grid
  file](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#theta_grid_knobs-equilibrium_option)
  input.

* [MXH geometry
  option](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#theta_grid_parameters-geotype).

* Added a [kinetic energy transfer
  diagnostic](https://gyrokinetics.gitlab.io/gs2/page/namelists/index.html#gs2_diagnostics_knobs-write_kinetic_energy_transfer).

* Added a very experimental fields based eigensolver. Set
  `USE_FIELDS_EIG=on` in addition to `USE_EIG=on` when running make.

* Around 22k lines removed from the repository without losing used
  features and being almost warning clean.

### Breaking Changes

* The entry points to GS2 when using it as a library have been
  refactored, with some deprecated routines having been removed. The
  main entry point is still `run_gs2`, but this now takes only three
  arguments: the program `state`, an option to delay finalising the
  simulation until `finish_gs2` is called and a flag to control
  verbosity of some output. The user is expected to take care of
  initialising and finalising MPI, and passing the MPI communicator
  through `state%mp_comm`.

* The change to the GS2 entry points means that some interfaces to
  external codes, such as Trinity, have also been removed. The caller
  should now handle any customisation to the GS2 setup/teardown.

* The "replay" feature to recalculate some diagnostics on a previous
  run has been removed. This feature only interacted with the "new"
  diagnostics module, and only a certain subset of diagnostics.

* Removed the parameters namelist (all relevant inputs now in
  knobs). Removed the `init_knobs` namelist.

* Remove `le_nxilim_fix`, `densfac_lin`, `kfilter`, `opt_init_bc`,
  `phifac_lin`, `qparfac_lin`, `qprpfac_lin`, `test`, `tparfac_lin`,
  `tprpfac_lin`, `uparfac_lin`, `wfb_cmr`, `bd_exp`, `fexpi`,
  `write_gg`, `write_lpoly`, `write_nl_flux`, `eqzip`, `faperp`,
  `harris`, `margin`, `secondary`, `tertiary`, `teti`,
  `trinity_linear_fluxes`, `trinity_ql_fluxes`, `gryfx`, `nkpolar`,
  `nterp`, `densfac`, `qparfac`, `qprpfac`, `tparfac`, `tprpfac`,
  `uparfac`, `nu`, `nustar`, `rmax`, `rmin`, `asym` and `asympri`
  inputs.

* `write_flux_line` defaults to false rather than true.

* Moved `wfbbc_option` from `dist_fn` to `le_grids`.

* Removed support for FFTW2 entirely.

### Known issues

No new known issues.

### Merged Pull Requests

* [Experimental] Field based eigval [PR #779 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/779)
* Feature/auto generate config for includes [PR #996 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/996)
* Strang splitting option in NL split operator [PR #665 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/665)
* Try to improve the consistency of the field solve in split_collisions [PR #614 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/614)
* Experimental/config auto gen ci test [PR #1004 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1004)
* Kinetic energy transfer diagnostic [PR #1003 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1003)
* Shaping paper transfer diagnostic parallel on updated master from gs2next 20240705 [PR #999 | Tobias Schuett](https://bitbucket.org/gyrokinetics/gs2/pull-requests/999)
* When building tests force MODDIR to be the directory containing the test source file [PR #1002 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1002)
* Minor/add some comments to get weights le grids [PR #1001 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1001)
* Bugfix/expand response matrix test [PR #374 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/374)
* Minor/tidyup makefile for 8p2 prep [PR #995 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/995)
* Fix most warnings in LOWFLOW build [PR #993 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/993)
* Minor/remove warnings and errors in genquad [PR #992 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/992)
* Take different approach to split long message [PR #998 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/998)
* Feature/use protected rather than public (not actually using protected here) [PR #973 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/973)
* Bugfix/energy exchange diagnostics [PR #997 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/997)
* Minor/fix two warnings in init g [PR #990 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/990)
* Minor/reduce visibility of layout type data [PR #983 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/983)
* Minor/reduce warnings for no netcdf build [PR #991 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/991)
* Feature/update to fftw3 modern interface [PR #987 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/987)
* Tweaks to allow LOWFLOW=on to build [PR #986 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/986)
* Bugfix/fixup more warnings in advance of 8p2 [PR #985 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/985)
* Move some velocity space / collision error related routines from dist_fn to diagnostics_velocity_space and related changes [PR #981 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/981)
* Minor/deprecate lowflow [PR #984 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/984)
* Add a parameter for noise initialization [PR #994 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/994)
* Minor/tweak make depend [PR #989 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/989)
* Minor/tidyup le grids use statements etc [PR #974 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/974)
* Bugfix/scale apar m by fapar [PR #979 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/979)
* Feature/progress status messages [PR #971 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/971)
* Minor/allow mult imp in linear and disable in nonlinear [PR #980 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/980)
* Always use nxi_lim instead of nxi+1 in collisions [PR #978 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/978)
* Remove fexpi and make fexp real [PR #976 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/976)
* Minor/refactor functional test for old diagnostics slightly [PR #972 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/972)
* Minor/update mpich ci build to f40 [PR #975 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/975)
* Minor/split multi module files [PR #982 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/982)
* Minor/fixup some more warnings [PR #977 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/977)
* Remove `ONE_STEP_PP` build option [PR #876 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/876)
* Minor/interim handling for cray with onestep [PR #969 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/969)
* Add Miller Extended Harmonic local equilibrium [PR #954 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/954)
* Minor/update dump grids to reuse gs2 io [PR #970 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/970)
* Minor/remove some unused makefile settings [PR #967 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/967)
* Bump Makefiles to get compiler flag variables [PR #962 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/962)
* Guard against points where we have marked them as zero iset [PR #963 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/963)
* Minor/small tweaks to preprocess fortdep make [PR #964 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/964)
* All restarting test to "build" if no netcdf [PR #965 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/965)
* Make sure we use run_name_size rather than hard-coding 2000 [PR #966 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/966)
* Remove duplicate comment from rungridgen [PR #968 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/968)
* Experimental/exponential decay boundaries [PR #961 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/961)
* Force std=f2008 in mpich CI job as we enable more features/code in this build [PR #959 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/959)
* Import tVec at outer level as well [PR #960 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/960)
* Try to work around slightly odd typedef [PR #958 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/958)
* [Experimental] Abort if the parameters namelist is present [PR #957 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/957)
* Cleanup/rearrange some trinity inputs [PR #953 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/953)
* Bugfix/make sure pfunit failure fails ci [PR #956 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/956)
* Minor/add some comments and tweaks around sdanalytic [PR #955 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/955)
* Minor/tidy up some more warnings [PR #952 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/952)
* Cleanup/remove gryfx references [PR #951 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/951)
* Feature/avoid duplicate points early in gridgen [PR #944 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/944)
* Micro/optimisations in opt source routines guided by intel advisor [PR #940 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/940)
* Minor/tidy up gridgen slightly [PR #943 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/943)
* Remove out of date bitbucket-pipelines.yml and related scripts [PR #949 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/949)
* Make sure we request a unit when opening (to delete) nc grid file [PR #950 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/950)
* Minor/remove unused code from gridgen smoothing [PR #942 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/942)
* Switch from intel to ifx COMPILER flag in CI [PR #948 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/948)
* Minor/update next for spline changes [PR #941 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/941)
* Silence more warnings [PR #947 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/947)
* Minor/gs2 save neasyf [PR #946 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/946)
* add B_T, aminor, grhoavg, and surfarea to the netcdf output of eiktest. this is useful for the geqdsk capabilities of T3D. [PR #945 | Noah Mandell](https://bitbucket.org/gyrokinetics/gs2/pull-requests/945)
* Bugfix/update unit test makefiles for more cleaning [PR #939 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/939)
* Minor/update utils and fix gs2 for removal of trin flags [PR #937 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/937)
* Experimental/avoid treating wfb as passing in conservative lorentz vpdiff [PR #931 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/931)
* Reorder dimensions in pitch_weights to better match access order [PR #936 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/936)
* Make vpar_zero_mean only apply to wfb rather than all trapped particles [PR #934 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/934)
* Remove le_nxilim_fix input [PR #933 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/933)
* Minor/tidyup some collisions code removing commented out parts and improving consistency [PR #932 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/932)
* Feature/try to optimise collision conservation terms in le lo [PR #930 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/930)
* Feature/add multigs2 runner as cleaner implementation of gs2 queue [PR #935 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/935)
* Minor/remove unused le grids public [PR #929 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/929)
* Minor/remove some unused integration implementations [PR #928 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/928)
* Minor/use xi compatible weights layout [PR #926 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/926)
* Minor/small tweaks to conserve collision terms [PR #927 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/927)
* Minor/swap dimension order in ixi to il and related to improve memory access pattern [PR #925 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/925)
* Minor/slight optimisation to lorentz conservation calculation for no drag [PR #922 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/922)
* Add missing vnmult(2) factor in one term of le_lo diffuse conserve [PR #921 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/921)
* Feature/use real type for coefficients in collisions setup [PR #920 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/920)
* Minor/dont pass hee out of init vnew [PR #924 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/924)
* Handle heating false when asking for heating diagnostics [PR #923 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/923)
* Minor/remove uses of erf ext in favour of language standard [PR #919 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/919)
* Minor/avoid duplication in collisions from select case [PR #915 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/915)
* Avoid scaling vnew* arrays by tunits(ik)/tunits(1) [PR #916 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/916)
* Avoid allocating vnewh if it will only store zero [PR #917 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/917)
* Reduce scope of glec [PR #918 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/918)
* Minor/avoid allocating c rate when not collisional [PR #914 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/914)
* Remove deprecated teti [PR #905 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/905)
* Minor/slight collisions tweaks to cache some results etc [PR #913 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/913)
* Broadcast species arrays directly rather than copying out into a temporary array first [PR #910 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/910)
* Remove determine_species_order and related variables [PR #912 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/912)
* Minor/update output of species parameters to capture changes [PR #911 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/911)
* Remove init_knobs namelist [PR #909 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/909)
* Minor/remove parameters namelist in favour of knobs [PR #908 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/908)
* Remove deprecated faperp input [PR #907 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/907)
* Remove deprecated margin input [PR #906 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/906)
* Add user input `ncheck_stop` to control the frequency at which we check for the presence of the <runname>.stop file [PR #904 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/904)
* Feature/add standards check to intel ci build [PR #898 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/898)
* Bugfix/ensure we use workaround for gfortran polymorphic argument issue with neasyf [PR #903 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/903)
* Fix type of nmesh in gs2_io [PR #902 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/902)
* Minor/slight optimisation in eqitem to reduce copying [PR #900 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/900)
* Minor/reduce memory overhead of geo type [PR #901 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/901)
* Guard theta_grid_eik warnings with proc0 [PR #899 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/899)
* Large geometry refactor to reduce code duplication, avoid module level state and enable external OpenMP use [PR #887 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/887)
* Enforce language standard f2008 in openmp CI case [PR #895 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/895)
* Improve handling of checking presence of pFUnit v4 [PR #896 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/896)
* Add CI_COMMIT_BRANCH to cache name [PR #897 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/897)
* Replace calls to `flush_output_file` with `flush` statement [PR #893 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/893)
* Replace use of imag with intrinsic aimag [PR #894 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/894)
* If esv then force application to all wavenumbers when using getan [PR #891 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/891)
* Bugfix/ensure procs with no data dont break max abs reduce [PR #890 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/890)
* Bugfix/change init order in ingen mod [PR #889 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/889)
* Remove out of date warning on nc_sync_freq [PR #888 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/888)
* Feature/update ci versions fedora to 39 [PR #892 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/892)
* Draft: Feature/geo isolation variables tidyup [PR #881 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/881)
* Add parallel netcdf CI build [PR #885 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/885)
* Bugfix/fix use of uninitialised variable in gf fields [PR #886 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/886)
* Switch from [[ == ]] to [ -eq ] [PR #883 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/883)
* Bugfix/remove mold in arrays where local bounds matter [PR #882 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/882)
* Define fields by all procs for parallel netcdf [PR #884 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/884)
* Improve geometry isolation [PR #880 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/880)
* Improve isolation / interface to split nonlinear operator. [PR #878 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/878)
* Change the default of proc_to_save_fields from -1 to 0 [PR #879 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/879)
* Bugfix/fix dipole coeffs [PR #740 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/740)
* Minor/remove test driver flag and functional test flag [PR #874 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/874)
* Minor: Tidy up parameter scan module [PR #872 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/872)
* Update utils to allow us to simplify call to init_file_utils [PR #875 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/875)
* Guard uses of optional arguments with present check in gs2_io_grids [PR #873 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/873)
* Minor: Tidy up gs2 main for 8 2 [PR #871 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/871)
* Fix up broken links in namelist documentation [PR #870 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/870)
* Rremove deprecated diagnostic flags [PR #869 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/869)
* Minor/remove unused enable parallel and related infrastructure [PR #868 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/868)
* Remove unused input nkpolar [PR #866 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/866)
* Minor/remove some unused inputs [PR #867 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/867)
* Minor/remove unused nu input [PR #865 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/865)
* Bugfix/fixup use of ikx and iky [PR #863 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/863)
* Bugfix: Remove lagrange interp write lpoly as not working [PR #862 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/862)
* Bugfix/fix gitlab ci for petsc failure due to make v441 and flags [PR #864 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/864)
* Feature/debug method save distfn slice regularly [PR #664 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/664)
* Micro optimisations for split integrators and nl term [PR #857 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/857)
* Minor/port update golden answers from pr #663 [PR #856 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/856)
* Minor/small tweaks to optimise eexchange 2 [PR #858 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/858)
* Switch to using neasyf in gs2_save_slice [PR #859 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/859)
* Extend fortdep to handle submodules [PR #860 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/860)
* Zero aj0 and aj1 in the forbidden region [PR #852 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/852)
* Change handling of tracer species in integrate methods to use cycle [PR #855 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/855)
* We don't use it/ik_u/llim in getan_from_dfn so don't both calculating them [PR #854 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/854)
* Feature/save a g_adjust per add nl [PR #853 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/853)
* Feature/reimplement theta0 dependence ideal ball [PR #849 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/849)
* Weight QL metric to field norm [PR #851 | Maurizio Giacomin](https://bitbucket.org/gyrokinetics/gs2/pull-requests/851)
* Feature/tool to split flux tube to ballooning space [PR #792 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/792)
* Add some golden answer tests of ideal_ball related ballstab code [PR #850 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/850)
* Minor/limit allocation of gexp arrays [PR #845 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/845)
* Minor/move vpar to dist fn arrays [PR #844 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/844)
* Minor: Separate vpa and vpar initialisation [PR #843 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/843)
* Minor/more openmp in copying initvals [PR #846 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/846)
* Minor/use array utils to copy and zero in a few more places [PR #848 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/848)
* Minor: Use array utils in init g [PR #847 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/847)
* Bugfix/dont treat passing wfb as periodic [PR #836 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/836)
* Minor/add passing like flag to simplify logic [PR #838 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/838)
* Minor/guard against zero max vel [PR #840 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/840)
* Remove attempts to override nx/ny in gs2_layouts [PR #839 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/839)
* More reuse of linked data in fields local [PR #820 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/820)
* Minor/track dump read response time [PR #841 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/841)
* Minor: Tidy up modep diagnostics flag [PR #842 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/842)
* Feature/theta grid file nc [PR #755 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/755)
* Experimental Feature : Allow linked boundary code to work with nonzero incoming and use solution at the previous step to set internal incoming boundary value [PR #823 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/823)
* Add routine to create incoming_links redistribute [PR #825 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/825)
* Experimental/try optimised passing weight split [PR #835 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/835)
* Feature/allow linked boundary code to work with nonzero incoming add runtime flag [PR #826 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/826)
* Add some more data about linked domains [PR #819 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/819)
* Draft: Make sure reset is set back to false after end of step reset_time_step [PR #832 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/832)
* Draft for 8.2 : Revert "Remove change to new_trap_int weights calculation for 8.1" [PR #523 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/523)
* Minor/make sure vpac vperp2 zero in forbidden [PR #833 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/833)
* Bugfix/remove some warnings [PR #829 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/829)
* Call ensure_single_val_fields_pass in the nogath antot pathway. [PR #828 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/828)
* Bugfix: Fix runtime errors in tests [PR #827 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/827)
* Initialize counter [PR #830 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/830)
* Write t_wstar only when writing = .true. [PR #831 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/831)
* Bugfix: Restore old approach to calculating dadj in linked wfb boundary conditions. [PR #824 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/824)
* Update utils commit to get fix to constant_random [PR #822 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/822)
* Bugfix: Don't use mold in picard allocation [PR #821 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/821)
* Bugfix/generalise ttp treatment in places [PR #767 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/767)
* Switch int for logical in fields local [PR #818 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/818)
* Feature/consistency check for linked boundaries [PR #817 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/817)
* Fix lots of warnings in tests [PR #794 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/794)
* Pull out linked boundary application to standalone and refactor slightly [PR #811 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/811)
* Minor/pull out linked boundary application to standalone add test [PR #815 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/815)
* Remove uses of prof module. [PR #816 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/816)
* Feature/improve consistency of periodic detection at low shear [PR #781 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/781)
* Expand comment around no comm and refactor some associated code [PR #806 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/806)
* Minor/refactor omega calculation to allow more reuse [PR #787 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/787)
* Field weighted kperp2 QL metric [PR #786 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/786)
* Remove wfb_cmr and related routines/variables [PR #808 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/808)
* In kt_grids_single set akx from theta0 or theta0 from akx [PR #788 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/788)
* Feature: Utility routine for conversion from flux tube to ballooning space fields [PR #810 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/810)
* Add supercell label array and write out to netcdf files. [PR #809 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/809)
* Make default boundary_option try to be more helpful. [PR #780 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/780)
* Make fileopt_base > 1 character [PR #812 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/812)
* Don't ignore test_*.in files in tests [PR #813 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/813)
* Add mixed_wfb flag to represent original mixed wfb treatment [PR #805 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/805)
* Draft: Feature/tidy up init connected bc reimpl some of pr 601 part 8 [PR #804 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/804)
* Feature/tidy up init connected bc reimpl some of pr 601 part 7 [PR #803 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/803)
* Feature/tidy up init connected bc reimpl some of pr 601 part 6 [PR #802 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/802)
* Feature/tidy up init connected bc reimpl some of pr 601 part 5 [PR #801 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/801)
* Feature/tidy up init connected bc reimpl some of pr 601 part 4 [PR #800 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/800)
* Restore GS2 optimisation functionality [PR #789 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/789)
* Feature/tidy up init connected bc reimpl some of pr 601 part 3 [PR #799 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/799)
* Feature/tidy up init connected bc reimpl some of pr 601 part 2 [PR #798 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/798)
* Tidy up init connected bc. Reimplement some of PR # 601. (Part 1) [PR #796 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/796)
* Makefile edited online with Bitbucket to fix GS2_BUILD_TAG evaulation [PR #797 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/797)
* Add build_tests and build_{unit,linear,nonlinear}_tests targets [PR #795 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/795)
* Add some generated files and executables to gitignore [PR #790 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/790)
* Add user-settable build tag that is displayed in standard header [PR #791 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/791)
* Feature/add ability to just build tests [PR #793 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/793)
* Feature/small savings in fields local field solve [PR #783 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/783)
* Time and report the response matrix inversions [PR #785 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/785)
* Feature/rationalise flux diagnostic settings [PR #771 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/771)
* Remove html tags in generated namelist docs [PR #784 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/784)
* Make tests reuse main Makefile's detected pytest [PR #782 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/782)
* Add a test based on a grid.out style geometry [PR #774 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/774)
* Add a utility routine to check arrays are zero in the forbidden region [PR #769 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/769)
* Construct artificial "old" fields from found eigenmode and eigenvalue [PR #777 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/777)
* Experimental/eigensolver based linear test [PR #778 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/778)
* Feature/reuse diagnostics routine to save distfn in eigval solver [PR #776 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/776)
* Try to call regular diagnostics for each eigenpair found. [PR #775 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/775)
* Invert logic in is_lower/is_upper_bounce point routines [PR #773 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/773)
* Add routine to check consistency of bounce point values in passed array [PR #770 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/770)
* Clean up simpledataio mentions from makefiles [PR #768 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/768)
* Fix many unused var warnings [PR #764 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/764)
* [Experimental] Add Picard split scheme integrator [PR #673 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/673)
* Feature/move some diagnostic routines out of dist fn [PR #761 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/761)
* Start to address issue 132 [PR #379 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/379)
* Remove replay feature [PR #763 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/763)
* Minor/move lowflow initialisation into lowflow module [PR #758 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/758)
* Try to improve clarity of init_wdrift and fix some potential inconsistencies/bugs [PR #756 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/756)
* Remove eqzip, secondary, tertiary and harris options [PR #752 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/752)
* Save kperp2 to netcdf [PR #721 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/721)
* Remove simpledataio [PR #590 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/590)
* Fix diagnostics test silently failing [PR #720 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/720)
* Minor/removed unused inputs in dist_fn [PR #762 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/762)
* Correct default fftw3 library link option [PR #760 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/760)
* Replace sqrt(abs(...)) with sqrt(max(0.0,...)) in collisions [PR #754 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/754)
* Minor/tag openmp build for more resource [PR #759 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/759)
* Change ieqzip from integer to logical [PR #751 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/751)
* Add an option to change normalization of dipole [PR #739 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/739)
* Force itor_over_B = 0 for qval = 0 [PR #733 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/733)
* Move down NETCDF_COMPRESSION check [PR #753 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/753)
* Reimplement PR #28 more generally [PR #747 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/747)
* More openmp in linked code and fields_local plus minor optimisations [PR #746 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/746)
* Minor: Small tweaks to split nonlinear rk impl [PR #749 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/749)
* Cache homogeneous solution [PR #205 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/205)
* Bugfix/build all in ci and fix pr 742 [PR #750 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/750)
* Minor : Remove some dist fn public statements [PR #742 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/742)
* Restructure mom coeff calculation [PR #741 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/741)
* Restructure le_derivatives to move most LOWFLOW code into single section [PR #736 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/736)
* Feature/logical version of g adjust [PR #745 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/745)
* Move init_vnm responsibility to collisions from run_parameters [PR #744 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/744)
* Feature/move time related init from run parameters to gs2 time [PR #743 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/743)
* Bugfix/git config safe directory web page build fix [PR #738 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/738)
* Add logicals to indicate if we have fields [PR #737 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/737)
* OpenMP default shared to none [PR #735 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/735)
* Very basic test for all diagnostics [PR #732 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/732)
* Read plot data from eik6.out file [PR #734 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/734)
* Helper script for theta grid file [PR #729 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/729)
* Initialize cdrift, cdrift0 [PR #725 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/725)
* Use neasyf wrapper for netCDF functions in old diagnostics [PR #587 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/587)
* Minor/more grid data to netcdf output [PR #730 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/730)
* Bump Python package versions [PR #727 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/727)
* PFunit coverage fixes [PR #728 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/728)
* Update utils to remove fft_save_widsom and fix interface issue [PR #724 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/724)
* Prefer to pass ulim rather than blocksize for opt_local_copy [PR #723 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/723)
* Bugfix/fix nl omp pragma [PR #722 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/722)
* Reuse "final" diagnostics routines between new and old modules [PR #453 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/453)
* Pass source into invert rhs 1 [PR #430 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/430)
* Add command line option to run ingen on input file [PR #581 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/581)
* Small changes to allow ffttester to still link correctly [PR #719 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/719)
* Bump utils for changes to fft_work [PR #717 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/717)
* Refactor preprocessor-guarded conditional [PR #718 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/718)
* Don't use diagnostics_config in final routines [PR #713 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/713)
* Remove ntg_out in volume_averages, using ntgrid directly instead [PR #715 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/715)
* Completely remove local `ng` variable from volume averages [PR #716 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/716)
* Bugfix : Remove timing stats in tests [PR #714 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/714)
* Drop support for FFTW2 [PR #712 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/712)
* If passed il isn't totally trapped anywhere then skip attempt to add ttp source in opt path [PR #711 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/711)
* Update utils to fetch allocatable redist buffers feature [PR #708 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/708)
* Remove build_gs2 link [PR #710 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/710)
* Also treat CFL violation as a failed step in split integrators [PR #666 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/666)
* Remove unsupported build_gs2 script [PR #585 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/585)
* Add OpenMP usage [PR #620 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/620)
* Bugfix : Fix pr #627 for persistent comms [PR #709 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/709)
* More openmp split nl module [PR #679 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/679)
* Add ability to ask for field calculation to only operate on local portion of kt grids. [PR #693 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/693)
* Add openmp to get fields from dfn and associated routines (getfieldeq1 etc.) [PR #691 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/691)
* Openmp collapse some loops [PR #692 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/692)
* Try to optimise collisions loops slightly [PR #703 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/703)
* Add logical methods in le grids for wrapping up standard logic to do with pitch angles and use these [PR #698 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/698)
* Bounce point detection lookup/logic [PR #700 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/700)
* Add routines for getting and saving statistics around timer values [PR #706 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/706)
* [Minor] Add time of field solve in split nl operator [PR #705 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/705)
* Add a flag to request the init timers are saved [PR #707 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/707)
* More openmp in collisions [PR #702 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/702)
* OpenMP use zero_array in le grids [PR #704 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/704)
* Move ittp from dist_fn_arrays/dist_fn to le_grids [PR #701 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/701)
* Make sure jend=0 when there are no trapped particles [PR #699 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/699)
* Move wfbbc option handling to le grids [PR #697 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/697)
* Default netcdf compression to off if building with parallel netcdf [PR #696 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/696)
* Add declaration of a variable [PR #695 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/695)
* Add initialization/finalization of mp [PR #694 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/694)
* Docs: Fix some links in the manual [PR #689 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/689)
* Avoid character truncation in rk_schemes. [PR #688 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/688)
* Remove mistaken element [PR #687 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/687)
* Set the communicator in state to fix transform_round_trip [PR #686 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/686)
* fixes to eiktest.f90 so that it compiles. add eiktest to gs2_all target. [PR #641 | Noah Mandell](https://bitbucket.org/gyrokinetics/gs2/pull-requests/641)
* Fix many warnings [PR #421 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/421)
* Bugfix/eiktest minor modification to address comments [PR #647 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/647)
* Add gs2 transform round trip tests [PR #674 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/674)
* Bugfix/allocatable property for optional config inputs [PR #685 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/685)
* Mark ab_coefficients argument as allocatable in source term routines [PR #684 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/684)
* Minor/save wstar units time [PR #683 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/683)
* Create single entry point for GS2 [PR #675 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/675)
* Update gfortran 11 CI to 12 and F35->F37 [PR #680 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/680)
* Tweak impact of QUIET make flag [PR #678 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/678)
* Bugfix/improve gs2 diagnostics new ascii test [PR #682 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/682)
* Skip writing to ascii files if we are in create mode [PR #681 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/681)
* Change name length to avoid compile error [PR #677 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/677)
* Add a method to help with debugging which calculates the relative difference on potentials passed and those calculated directly from a passed g [PR #668 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/668)
* Small reduction in RK integrator operations and slight tidy up [PR #672 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/672)
* Add non-error controlled Euler RK scheme [PR #669 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/669)
* Pass time step to take to the nonlinear integrators [PR #671 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/671)
* Change split_method default to be RK [PR #670 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/670)
* Add test to check new namelists are added to namelist collection [PR #659 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/659)
* Wrap object dependencies in ifndef block [PR #662 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/662)
* Debugging : Flags to turn off nl components [PR #660 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/660)
* Tweak handling of max_sim_time and other exit states [PR #667 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/667)
* Remove HDF5 flags from build system [PR #658 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/658)
* Add split_nonlinear_terms to config_collection [PR #656 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/656)
* Add test of nonlinear runs via flux [PR #655 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/655)
* Skip communication of forbidden region in NL transforms (related to pr #547) [PR #650 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/650)
* Start to improve gs2_init code [PR #600 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/600)
* Split nonlinear : User can specify relative and absolute tolerance [PR #651 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/651)
* Ensure we don't allocate when we don't have data [PR #653 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/653)
* Remove field solve at end of RK integrator as we do not use the final field for anything. [PR #652 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/652)
* Feature/smaller restart files [PR #648 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/648)
* Turn netcdf compression on by default [PR #649 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/649)
* Fix split nonlinear algorithm and refactor [PR #645 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/645)
* Bugfix/write diagnostics at the end of the run [PR #646 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/646)
* Add split nonlinear namelist [PR #644 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/644)
* Split nonlinear term and evolve separately [PR #640 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/640)
* Move advance nonlinear term method to a new module [PR #643 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/643)
* Add beuler error control test [PR #642 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/642)
* Allow user to specify nproc for most layouts [PR #632 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/632)
* Refactor redistribute creation [PR #627 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/627)
* Require at least gfortran 9 [PR #588 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/588)
* Remove use of `command_line` module [PR #580 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/580)
* Stop parsing the command line when we find `--` [PR #633 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/633)
* Require python3 for all build system scripts [PR #639 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/639)
* Avoid potential use of uninitialised data in remove zonal flow [PR #635 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/635)
* Add kxfac to netcdf outputs [PR #638 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/638)
* Bugfix/geo eiktest dipole [PR #630 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/630)
* Update ford version and pin markupsafe [PR #629 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/629)
* Pass in nproc and iproc when constructing layouts [PR #623 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/623)
* Merge release 8.1.2 into next [PR #628 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/628)
* Add constant initial conditions option [PR #603 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/603)
* Open text output file from proc0 only [PR #604 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/604)
* Try to give theuser ownership of the checked out repo [PR #602 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/602)
* Update next with 8.1.1 [PR #599 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/599)

## 8.1.2 (2022-07-26)


### Breaking Changes

* Correction for collisional treatment with `new_trap_int = T` may change results.

* Correction for nonadiabatic dfn initial conditions with adiabatic
  species may prevent reproducibility of previous simulations (but not
  change the physics of the time advance).

### Known issues

No new known issues.

### Merged Pull Requests
* Bugfix/correct calculation of potentials from nonadiabatic dfn [PR #616 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/616)
* Fix handling of response_dir and inputs specified by path [PR #621 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/621)
* Correct ky/kx factors to use in ingen when reporting sweetspots for xxf/yxf [PR #622 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/622)
* Minor/ensure more consistent handling of omp inversion [PR #619 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/619)
* Add some tests with the collision operator active [PR #615 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/615)
* Tweak LICENCE to better match expected format [PR #625 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/625)
* Bugfix/allow new trap int with collisions [PR #618 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/618)
* Minor/report values when functional tests fail [PR #617 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/617)
* Add compiler time option to avoid f2008 compiler_version/compiler_options [PR #609 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/609)
* Feature/keep initial field if nonadiabatic initial condition [PR #613 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/613)
* Make init g dependency of run_parameters explicit [PR #611 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/611)
* Bugfix/restore condition number from response matrix file [PR #610 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/610)
* Backport PR #604 [PR #606 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/606)
* Bugfix/guard open output file on multiple procs [PR #607 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/607)
* Minor/remove get unused unit calls [PR #608 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/608)
* Backport PR #602 [PR #605 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/605)

## 8.1.1 (2022-04-29)

### Breaking Changes

* Previously if gridgen failed it would report the failure but the run
  would continue. The run will now abort.
* Collisional electromagnetic simulations with normalising
  density/charge not equal to one previously missed a normalising
  factor in the drag term. This has been fixed but may change results.

### Known issues

No new known issues.

### Merged Pull Requests

* Update utils and Makefiles for 8.1.1 and README doi [PR #598 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/598)
* Integrate to final time [PR #594 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/594)
* Use a broadcast rather than an allreduce to send the read in response matrix data in fields_local [PR #591 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/591)
* Bugfix/improve init level list order to avoid excess work [PR #597 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/597)
* Add linear tests with different normalisations [PR #592 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/592)
* Add -1/(q_e n_e) factor to collisional drag term. [PR #593 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/593)
* Make sure header created on all procs. [PR #596 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/596)
* Make sure we set the index for indexed namelists when allocating them in config_collection write [PR #595 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/595)
* Make new diagnostics respect write_ascii flag. [PR #589 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/589)
* Trim white space when reporting file_proc [PR #584 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/584)
* Abort if gridgen ends with an odd ntheta [PR #582 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/582)
* Report time spent in ffts [PR #579 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/579)
* Bugfix : Fix performance of collisional conservation terms in le_lo [PR #573 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/573)
* Convert guidance to stop run to abort call [PR #577 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/577)
* Ignore some more GS2 generated files [PR #576 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/576)
* Always treat the dfn from restart files as gnew. [PR #572 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/572)
* Use helper function to format timer lines [PR #575 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/575)
* Minor/add collision and explicit mpi time breakdown [PR #574 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/574)
* Add Fujitsu and NEC compilers in define.inc [PR #571 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/571)
* Update next with 8.1.0 release [PR #570 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/570)


## 8.1.0 (2021-12-10)

### Breaking Changes

*From v8.1 onwards, we will be recording breaking changes. GS2 development
policy is to minmize disruption to users by only introducing breaking changes
into major and minor releases (e.g. v8, v8.1, but not v8.1.1). By "breaking
change", we mean anything (that isn't a bug fix!) that will change the physics
results or lead to different/unexpected code behaviour without the user
changing anything in their input file. This typically means changes to
defaults, or improvements to physics/algorithms that change the results but
aren't fixing a definite bug.*

The breaking changes for v8.1 are:

* [PR 353 Ensure maximum timestep stored in restart](https://bitbucket.org/gyrokinetics/gs2/pull-requests/353/).
With this change, the maximum time step (input variable `dt0`) is stored in
the restart file and is restored when `delt_option = 'check_restart'`. The
value used can still be overridden by setting `dt0`.  This breaks backwards
compatibility with pre-8.1 restart files: now if `delt_max` is not found in
the restart file then we would fail to set the maximum time step or the time
step history from the restart file, and an error is thrown.
* `opt_redist_init` is no longer an option - we only support the optimal
  version of the redistribution initialization routine. **Users need** to
  remove `opt_redist_init` from `layout_knobs` namelist in input files.
* For consistency, the new diagnostics now uses lower case for `rplot`,
  `zplot`, `rprime` and `zprime`. This has the potential to **break analysis
  scripts**.
* **Changes to defaults**: `write_fluxes` and `write_fluxes_by_mode` now
  default to `true` for nonlinear runs and `false` for nonlinear runs.
* Runs **now abort** if the user attempts to load a restart file with a
  different layout than the one set in the rest of the code / input file.

### Known issues

* If users see compile/cleaning errors relating to tests, it may be necessary
  to delete folders for benchmarks that no longer exist in 8.1:
```
rm -rf tests/benchmarks/init
rm -rf tests/benchmarks/timestep
```

* Switched to the NETCDF4 file format for all netcdf output. Existing
  analysis tools should continue to work, however, this generally means
  one should not access the netcdf files whilst the run is ongoing by
  default. For example, running `ncdump` on an in use file is likely
  to return a HDF error. *To avoid this and allow access during a run
  one can set `HDF5_USE_FILE_LOCKING=FALSE` in the environment*
  (e.g. `export` this in bash)*.


### Merged Pull Requests

* Release notes for 8.1. These are partial release notes - notes are easier to finalize in the RC branch. [PR #414 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/414)
* Bugfix/avoid serial mp clobber [PR #569 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/569)
* Show change log and release notes on website [PR #568 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/568)
* Small optimisations for exb routine [PR #551 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/551)
* Don't communicate forbidden region in `g_lo <-> le_lo` redistribute [PR #549 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/549)
* Write version (and some other metadata) to netcdf files [PR #565 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/565)
* Add MODDIR to some dependenices to avoid warnings when preprocessing with gfortran [PR #567 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/567)
* Make some targets always serial [PR #566 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/566)
* Mark hybrid electrons as experimental [PR #555 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/555)
* Hybrid electrons with less code [PR #539 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/539)
* Add random_sine initial condition. [PR #556 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/556)
* Minor/dont restrict time message to proc0 [PR #563 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/563)
* Feature/report field solve mpi time [PR #562 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/562)
* Feature/report collisions and nl time breakdown [PR #559 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/559)
* Report redistribute timer breakdown in time report [PR #553 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/553)
* Make sure use_sub is false if the x dimension is split [PR #548 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/548)
* If either nx or ny are zero then we cannot setup the transforms so detect this and abort with a helpful message [PR #557 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/557)
* Add vparknob used to scale vparallel [PR #554 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/554)
* Add skip gridgen flag [PR #544 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/544)
* Report mpi timers at end of run [PR #552 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/552)
* Make sure ingen respects npmax input [PR #558 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/558)
* Feature/update ci builds for 8 1 release [PR #561 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/561)
* Write time at which run finishes [PR #564 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/564)
* Fixup pfunit install script to allow user use and use in CI [PR #560 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/560)
* Duplicate code for saving/restoring kx_shift for theta0_shift [PR #550 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/550)
* Fix some uses of gnu extensions [PR #546 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/546)
* Disable memory usage message by default and enable through make flag. [PR #545 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/545)
* Bugfix/namespace parallel flag [PR #543 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/543)
* Guard writing used inputs file on rank0 [PR #542 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/542)
* Minor bug fix to respect nonad_zero in linked wfb twist-shift conditions [PR #540 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/540)
* Add tools for estimating current and peak memory usage. [PR #536 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/536)
* Towards enabling netcdf compression in restart file [PR #538 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/538)
* Remove contribution to conservation terms from hybrid-passing electrons [PR #535 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/535)
* Fix for markdown nested in HTML for namelist docs [PR #537 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/537)
* Exclude hyper terms when istep <= 0 [PR #528 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/528)
* Try to account for change in MPI flag name for pfunit between v3 and v4 [PR #534 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/534)
* Unit test to check invalid inputs are failure and other handling of the input file [PR #526 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/526)
* Create new netCDF files using the netCDF-4 model [PR #533 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/533)
* Improve error message if pFUnit is not found [PR #532 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/532)
* Initialise some flags in gs2 save and improve restart file treatment [PR #524 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/524)
* Bugfix/improve vnmult restore handling issue 63 [PR #531 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/531)
* Bugfix/check indexed namelist existence before read [PR #527 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/527)
* Minor/reduce memory consumption associated with c_rate [PR #525 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/525)
* Bugfix Fix coverage ci hang and pfunit 3 build [PR #529 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/529)
* Improve new trap int weights convergence/behaviour [PR #397 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/397)
* Remove change to new_trap_int weights calculation for 8.1 [PR #522 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/522)
* Reduce cyclone_itg NL test case size [PR #519 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/519)
* Try to make gs2_diagnostics test better resolved [PR #521 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/521)
* Add an example of a test expected to fail [PR #485 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/485)
* Dont always print blank line in close_module_test [PR #520 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/520)
* Feature : Error based NL time step estimate [PR #357 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/357)
* Make sure betaprim is initialised [PR #518 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/518)
* Draft: Bugfix/remove some directives from gs2 save to improve clarity [PR #516 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/516)
* Make sure kt_grids_knobs wnml output is a valid namelist [PR #517 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/517)
* Use ulim_alloc rather than ulim_proc when reversing array [PR #513 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/513)
* Enable debug for gfortran 5 build [PR #514 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/514)
* Bugfix/dont leave early if no elements in save read restart files [PR #515 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/515)
* Write out input parameters with their used values, add header to some files [PR #410 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/410)
* Bugfix/add ci case with ffpe trap [PR #507 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/507)
* Write out condition number for response matrices [PR #475 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/475)
* Bugfix/initialise ctmp in collisions [PR #512 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/512)
* Replace `write_hrate` with `write_heating` [PR #484 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/484)
* Remove jacob from eik_get_grids and salpha_get_grids interface as not set [PR #511 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/511)
* Attmept to fix bug in crpgrad not being initialised [PR #510 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/510)
* Avoid error from invalid floating point operation [PR #499 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/499)
* Workaround for Cray bug which didn't like type renaming on use [PR #497 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/497)
* Don't call new diagnostics clean up if using old diagnostics [PR #505 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/505)
* Make sure thetaShift and beta_0 are set when setting surface properties for testing [PR #509 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/509)
* Bugfix/avoid uninitialised data in replay mode [PR #503 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/503)
* Guard against some potential uses of uninitialised file units [PR #506 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/506)
* Ensure `big` is initialised prior to use. [PR #508 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/508)
* Initialise outputs in getan_nogath [PR #502 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/502)
* Ensure D_v and D_eta are always initialised [PR #500 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/500)
* Try to avoid divide by zero in estimate_error [PR #501 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/501)
* Initialise user_dt_cfl and code_dt_cfl to dt_not_set [PR #504 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/504)
* Better warning if Python not found [PR #498 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/498)
* Feature/decouple geometry theta resolution [PR #435 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/435)
* Experimental: Basic command line arguments [PR #350 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/350)
* Bugfix/tidy up slab itg linear test [PR #496 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/496)
* Merge advance and init benchmarks into single executable [PR #366 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/366)
* Remove duplicated variable in antenna [PR #489 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/489)
* Bugfix/add timestep change test [PR #493 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/493)
* Improve the formatting of the config namelist output [PR #495 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/495)
* Bugfix/reduce large automatic arrays [PR #494 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/494)
* Bugfix/fix in memory not storing explicit source history [PR #490 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/490)
* Bugfix/avoid resetting istep last in timestep change [PR #488 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/488)
* Ensure that initialized in gs2_init defaults to false. [PR #492 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/492)
* Add option to change size of benchmark tests [PR #193 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/193)
* Fix Ford interceptor script to be compatible with Ford 6.1 [PR #486 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/486)
* Put breaking changes in changelog [PR #483 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/483)
* Change wdriftttp to be distribution function shaped. [PR #269 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/269)
* Move iglo loop into invert_rhs_1 and restructure [PR #429 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/429)
* Enable `file_safety_check` in new diagnostics [PR #452 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/452)
* Small tweak to account for change in type of gexp_1 with SHMEM [PR #482 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/482)
* Use periodic spline in eeq for periodic boundary values [PR #444 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/444)
* Bugfix/ensure periodic splines dont use duplicate point [PR #447 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/447)
* Slepc helper and ci [PR #477 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/477)
* Feature : Enable wider reuse of distribution function work space array [PR #424 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/424)
* Feature/cache pfunit build in ci test [PR #479 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/479)
* Minor/tidy up intel ci commands [PR #480 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/480)
* Don't report the trapped/passing error breakdown for Radau-Gauss grids [PR #481 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/481)
* Bugfix/ensure maximum timestep stored in restart [PR #353 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/353)
* Feature/calculate fields from nonadiabatic dist fn [PR #426 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/426)
* Refactor lgridset [PR #395 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/395)
* Add some flags to give more control over building pfunit [PR #478 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/478)
* Correct type in collision_model documentation [PR #455 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/455)
* Replace ruby with python [PR #468 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/468)
* Make sure INCLUDES is always passed to preprocessor commands [PR #476 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/476)
* Add option to eigensolver to look at time derivative operator [PR #473 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/473)
* Update namelist docs [PR #471 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/471)
* Add a test for the field equation consistency [PR #474 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/474)
* Tidy up test cleancommand [PR #460 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/460)
* Correct l2norm calculation for complex variables [PR #472 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/472)
* Add changes missing from PR 448 required to register cgyro option [PR #470 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/470)
* Fix typo, density->temperature [PR #469 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/469)
* Fix for fact SLEPc removed FEAST for v3.12 and v3.13 [PR #467 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/467)
* Make sure a few of our helper codes are built by default [PR #465 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/465)
* Try auto-enabling colour output from make [PR #464 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/464)
* Tweak how we set GK_HEAD_DIR and report the value in test_make [PR #463 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/463)
* Add handling of dotL files generated by NEC [PR #459 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/459)
* Add width to L edit descriptor [PR #458 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/458)
* Feature/nonlinear cfl diagnostic extensions [PR #457 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/457)
* Appends old diag NetCDF output when restarting [PR #314 | Bhavin Patel](https://bitbucket.org/gyrokinetics/gs2/pull-requests/314)
* Makefile optimisation [PR #451 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/451)
* Correct get init field for finite beta no bpar [PR #449 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/449)
* Added CGYRO like initialisation of g [PR #448 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/448)
* Add test and docs for restarting [PR #446 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/446)
* Use a wrapper for some netcdf calls in gs2_io [PR #445 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/445)
* Updating makefiles commit [PR #450 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/450)
* Only warn about non-functional diagnostics on proc0 [PR #443 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/443)
* Docs: Add a glossary page with some common abbreviations [PR #442 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/442)
* Replace `is not` with `!=` in python helper [PR #441 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/441)
* Fix init_knobs namelist getting included twice in docs [PR #305 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/305)
* Add force_collisions flag to force the application of collision operator even if vnewk = 0 [PR #440 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/440)
* Add reports of the passing and trapped pitch angle weight errors [PR #436 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/436)
* Add homogeneous source option. [PR #431 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/431)
* Add missing diagnostics from single config file [PR #422 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/422)
* Ensure that when we reset the time step we choose a new time step which no longer violates the cfl relations. [PR #380 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/380)
* Correct the dimension order when defining the energy grid weights [PR #437 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/437)
* Add some documentation for using gs2 on archer2 [PR #434 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/434)
* Matrix inversion benchmark tool [PR #428 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/428)
* Add lapack support [PR #416 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/416)
* Reduce memory pressure in inversion [PR #433 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/433)
* Remove wildcard in package name [PR #432 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/432)
* Update Makesfiles commit to get changes to YPI server makefile [PR #427 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/427)
* Use compiler flag for module compilation/search directory [PR #359 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/359)
* Bump Python netCDF package version [PR #420 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/420)
* Enable `save_glo_info_and_grids/save_velocities` in old diagnostics [PR #419 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/419)
* Use a single config type for both old and new diagnostics [PR #407 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/407)
* Add condition number calculation [PR #376 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/376)
* Minor g adjust optimisation [PR #417 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/417)
* Remove duplicated header [PR #418 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/418)
* Add option to use aslfftw3.f [PR #368 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/368)
* Add gds23, gds24 and gds24_noq to the output files [PR #401 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/401)
* Add dumping of velocity space weights to dump_grids output [PR #400 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/400)
* Allow number of untrapped pitch angles `ng2` to be set directly in the input file. [PR #399 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/399)
* Calculate estimate of error on vspace weights and report to file [PR #398 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/398)
* Add some documentation on writing pfunit tests [PR #405 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/405)
* Bugfix/update pip in gitlab [PR #415 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/415)
* Add geometry outputs to dump_grid output file [PR #413 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/413)
* Bugfix for nperiod > 1 [PR #371 | Jason Parisi](https://bitbucket.org/gyrokinetics/gs2/pull-requests/371)
* Remove jenkins [PR #340 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/340)
* Updates to README and documentation [PR #412 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/412)
* Update next with 8.0.6 and resolve conflicts [PR #411 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/411)
* Add a test and some documentation for kt_grids_box [PR #406 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/406)
* Add documentation for diagnostics inputs [PR #355 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/355)
* Feature/config type collection [PR #248 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/248)
* Relax constraints relating naky to ny and ntheta0 to nx in box mode. [PR #316 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/316)
* Add `include_explicit_source_in_restart` input flag [PR #208 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/208)
* Replace 2*ngauss with ng2 to ensure consistency [PR #393 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/393)
* Feature/add le grids integrate tests [PR #392 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/392)
* Add box mode linear itg test [PR #383 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/383)
* Experimental/improve coveralls reporting [PR #388 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/388)
* Ignore absence of explicit source terms in restart files [PR #222 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/222)
* Change the default of bouncefuzz to address issue #116 [PR #313 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/313)
* Experimental/try an old fedora build [PR #390 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/390)
* Remove travis yaml as we no longer use Travis [PR #389 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/389)
* Ensure we specify an image for the pages build [PR #387 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/387)
* Minor makefile tweaks to use fixed assignment. [PR #386 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/386)
* Feature/improve and expand gitlab [PR #385 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/385)
* Enable new diagnostics on the standard gitlab build [PR #381 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/381)
* Remove Travis Mac build as this will soon not be available without purchasing credits [PR #365 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/365)
* Feature/improve response matrix dumping issue #96 [PR #293 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/293)
* Tweak gitlab yaml to ensure failures always reported [PR #373 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/373)
* Ensure the fields implicit matrices read/write in the same order as the fields local ones [PR #362 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/362)
* Feature/tidy adams bashforth coefficient calculation [PR #367 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/367)
* Change approach to creating supercell and ky sub-communicators to try to [PR #358 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/358)
* Feature/expand travis builds [PR #331 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/331)
* Fix logic checking requested pfunit version [PR #334 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/334)
* Pass the value of PFUNIT_VERSION_MAJOR to the build_pfunit script [PR #333 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/333)
* Feature/remove some unused fields local code [PR #360 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/360)
* Pin markdown version to avoid hang experienced on gitlab [PR #356 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/356)
* Minor tweak to optional pages job for gitlab CI [PR #354 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/354)
* Feature/add test intel travis build [PR #337 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/337)
* Add an initial Mac Travis build [PR #335 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/335)
* Feature/add travis coverage job [PR #336 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/336)
* Change the way to apply preprocessor options [PR #347 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/347)
* Bugfix/fix gs2 diagnostics new unit test [PR #348 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/348)
* Feature/simple hyperviscosity mrh resolved [PR #345 | Michael Hardman](https://bitbucket.org/gyrokinetics/gs2/pull-requests/345)
* Resolve conflicts in PR 343 [PR #344 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/344)
* Remove dollar for carriagecontrol [PR #338 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/338)
* Fix intent attribute of sfile for open/create [PR #339 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/339)
* Bring in 8.0.5 history to next [PR #332 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/332)
* Suppress .optim file [PR #327 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/327)
* Feature/start travis integration [PR #330 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/330)
* Experimental/test why gitlab not reporting failure [PR #329 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/329)
* Update golden answers due to bug fix in 8.0.5-RC [PR #328 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/328)
* Update next with 8.0.5 and resolve conflicts [PR #326 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/326)
* Bump package version for numpy to make compatible with Ubuntu 20.04 [PR #315 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/315)
* Add zonal flow residual linear test [PR #246 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/246)
* Add empty namelists to suppress warnings [PR #321 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/321)
* Add FPPFLAGS to fpp.f90 target in tests_common [PR #320 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/320)
* Fix Jenkins trying to fetch more than required from submodules [PR #318 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/318)
* Remove unused lines from template, missing in source [PR #317 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/317)
* Fix initial theta grid size potentially unset in call to eikcoefs [PR #306 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/306)
* Docs/namelist vars link to self [PR #312 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/312)
* Feature/try to improve subcommunicator creation in fields local with mpi undefined [PR #307 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/307)
* Allow linking directly to namelists and input parameters [PR #309 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/309)
* Documentation/port more namelist documentation from sourceforge [PR #304 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/304)
* Experimental bugfix/fix gitlab status file permissions [PR #296 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/296)
* Start porting documentation from wiki to website [PR #300 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/300)
* Fix pfunit_tests recipe not returning correct status [PR #291 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/291)
* Fix minor bugs in ceq and add tests [PR #298 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/298)
* Report status of website build [PR #303 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/303)
* Micro/docs auto rebuild website branches [PR #302 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/302)
* Switch from `only` to `rules` to determine when to rebuild the website. [PR #301 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/301)
* Remove unused vars [PR #297 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/297)
* Add routine to dump the current source term [PR #294 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/294)
* Feature/user control netcdf sync [PR #295 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/295)
* Merge 8.0.4 release into next [PR #287 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/287)
* Fix bug where missing Ford error message was lost [PR #268 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/268)
* Feature/allow user random seed [PR #245 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/245)
* Force lower case for Rplot/Zplot/Rprime/Zprime for consistency [PR #272 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/272)
* Ensure we call processName on generated source files [PR #262 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/262)
* Remove dead code in gs2_io that could never be run [PR #267 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/267)
* Fixup/merge 803 into next [PR #252 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/252)
* Also report actual code time corresponding to timestep [PR #249 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/249)
* Make smart defaults for write_fluxes and write_fluxes_by_mode [PR #211 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/211)
* Ensure we always go through `init_antenna` rather than `read_parameters` during init. [PR #226 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/226)
* Save layout string in netcdf outputs [PR #210 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/210)
* Bugfix/avoid long lines in namelist related generated code [PR #218 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/218)
* Add webpage on developer meetings [PR #239 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/239)
* Expand namelist documentation [PR #213 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/213)
* Don't initialise the g2gf layout if we're not using gf_lo integrate [PR #206 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/206)
* Move `plotdata` call earlier in eikcoefs to avoid issue with theta being redefined. [PR #225 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/225)
* Increase the size of keys allowed when writing namelist from config [PR #198 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/198)
* Add rplot, zplot, aplot, rprime, zprime, aprime and bpol to netcdf output [PR #224 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/224)
* Add usual module level initialized variable for consistency [PR #223 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/223)
* Fix in config code generator - use the instance name rather than generic config_internal. [PR #221 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/221)
* Don't post test results messages to Slack [PR #194 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/194)
* Bugfix/fix gitlab not reporting pfunit failure [PR #216 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/216)
* Feature/avoid full path in makefile output [PR #162 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/162)
* Use experimental config types in pfunit tests [PR #163 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/163)
* Add missing max_unbalanced_yxf input object for the layouts namelist [PR #202 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/202)
* Read utils and Makefiles git hashes in make [PR #209 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/209)
* Use exit code in job manage test [PR #204 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/204)
* Add comment on when the nonlinear term is calculated [PR #189 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/189)
* Fix leq theta grid and add tests [PR #197 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/197)
* Was mistakenly declared as real but should be integer [PR #200 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/200)
* Minor bugfix for set_dimension_order_xxf/yxf [PR #199 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/199)
* Update Makefiles commit to fix issue #80 [PR #190 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/190)
* Tidy benchmarks [PR #192 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/192)
* Remove `opt_redist_init` flag from benchmarking input files [PR #191 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/191)
* Feature/remove unoptimised redist init [PR #168 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/168)
* Stop launching tail in the background when running pfunit_tests [PR #188 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/188)
* Adds missing `nopass` to a couple of generated config lines [PR #187 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/187)
* Experimental/type for run configuration [PR #152 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/152)
* Ensure tolerance specified for all assertEqual in leq pfunit tests [PR #183 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/183)
* Add standard header to input files [PR #186 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/186)
* Remove unused diagnostics_config namelist from tests [PR #185 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/185)
* Allow OpenMPI to oversubscribe on GitLab CI [PR #184 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/184)
* Fix fields_local benchmark [PR #179 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/179)
* Micro/layouts reduce duplication [PR #178 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/178)
* Bugfix/minor makefile add includes to c compile command [PR #173 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/173)
* Remove select case(layout) from indexing routines [PR #175 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/175)
* Bugfix/more consistent module move makefile [PR #177 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/177)
* Remove use c index [PR #174 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/174)
* Ensure gs2_slab_itg is cleaned from the linear unit test [PR #176 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/176)
* Indexing tests and benchmarks [PR #171 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/171)
* Remove unused code associated with unused layouts gint_lo and geint_lo [PR #172 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/172)
* Small tidy of gs2 layouts [PR #169 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/169)
* Feature/ford manual outline [PR #167 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/167)


## 8.0.6 (2021-02-04)

* 8.0.6 [PR #396 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/396)
* Ensure we call set_init_fields to setting initial fields at the start of a run if not restarting. [PR #402 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/402)
* Bugfix for nperiod > 1 rebased for 8.0.6 RC [PR #409 | Jason Parisi](https://bitbucket.org/gyrokinetics/gs2/pull-requests/409)
* Backport gitlab to 8.0.6 [PR #403 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/403)
* Add instructions on making a release [PR #404 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/404)
* Fix for issue #138 : Ensure correct size of dimension_names array in new diagnostics distributed field code [PR #394 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/394)
* Ensure istep used in new diagnostics is not negative. [PR #377 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/377)
* Pass `nth` rather than `ntgrid` to `leqin` [PR #372 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/372)
* Pass the value of PFUNIT_VERSION_MAJOR to the build_pfunit script [PR #351 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/351)
* [backport] Fix logic checking requested pfunit version [PR #352 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/352)
* Bugfix/fix parallel netcdf inconsistent defines [PR #341 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/341)


## 8.0.5 (2020-09-02)

* 8.0.5 RC [PR #322 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/322)
* Backport/PR 306 to 8.0.5 RC [PR #319 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/319)
* Update utils and makefiles for 8.0.5 [PR #323 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/323)
* Fix Jenkins trying to fetch more than required from submodules [PR #324 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/324)
* Bugfix/fix some valgrind warnings testsuite 8 0 5 [PR #311 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/311)
* Bugfix/fix efit aminor duplicate point skip [PR #308 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/308)
* Fix calculation of the extended domain length for cases with more than one field [PR #299 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/299)
* Fix single precision build [PR #288 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/288)


## 8.0.4 (2020-03-19)

* Update utils to 8.0.4 [PR #284 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/284)
* Update DOI for 8.0.4 [PR #283 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/283)
* Fix multiple calls to `eikcoefs` when using CHEASE equilibrium [PR #271 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/271)
* Guard against a `mod` call with a potential second argument of 0 [PR #282 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/282)
* Implement `write_eigenfunc` in new diagnostics [PR #281 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/281)
* Respect `force_maxwell_reinit` input file value [PR #255 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/255)
* Introduce python for use in testing [PR #278 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/278)
* Slightly reorder operations in calculation of `apar_m` to improve cancellation [PR #280 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/280)
* Report GitLab test runner failures [PR #279 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/279)
* Remove unused `BLUEGENEARGS` makeflag [PR #277 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/277)
* Fix dim divides logic [PR #275 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/275)
* Make sure that we always write the exit reason to file even if not built [PR #274 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/274)
* Ensure skip message is written out during tests [PR #273 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/273)
* Fix wrong energy grid dimensions in `dump_grids` [PR #258 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/258)
* Fix PETSc, SLEPc interfaces for >=3.8.0 [PR #261 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/261)
* Fix normalisations output [PR #260 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/260)
* Bug fix: Guard against repeated deallocations [PR #259 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/259)
* Try to ignore temporary files when searching for pfunit tests [PR #257 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/257)


## 8.0.3 (2020-02-07)

* 8.0.3 Release [PR #229 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/229)
* Update 8.0.3-RC latest versions of utils and Makefiles [PR #250 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/250)
* Update code exit information [PR #237 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/237)
* Rename theta_grid:eps to theta_grid:eps_trapped to distinguish this from the related theta_grid_params:eps used by the s-alpha model [PR #242 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/242)
* Update for changes in utils [PR #247 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/247)
* Reorder statements to ensure we set variables based on the input values rather than the default values [PR #244 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/244)
* Fix typo in README: "CPP Plasma" to "CCP Plasma" [PR #243 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/243)
* Append fresh exit reasons instead of overwriting [PR #241 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/241)
* Add smart default for write_nl_flux in old diagnostics [PR #240 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/240)
* Try switching netcdf source to github from unidata ftp [PR #238 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/238)
* Use exit code in job manage test [PR #204 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/204)
* Bug fix: update dump response [PR #236 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/236)
* Minor bug fix: ensures that building auxiliary programs (such as dump_response etc.) will create bin (or more strictly `$(BINDIR)` ) if it doesn't exist. [PR #235 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/235)
* Make smart default for write_fluxes [PR #212 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/212)
* Fix Jenkins checkout due to update of plugin [PR #228 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/228)
* Add explicit targets to the generated source files [PR #180 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/180)
* Make sure we respect read-only petsc vectors [PR #166 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/166)
* Fix bug in gs2_save: restart files incorrectly tried to save and restore the last but two timestep size, resulting in potentially undefined coefficients for restarted runs. [PR #201 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/201)
* Avoid requiring SLEPC_ARCH to be set for eigensolver builds. [PR #181 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/181)
* Bug fix for fortdep: allow it to recognise abstract interface [PR #182 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/182)
* Ensure we increment nout before leaving the diagnostics routine [PR #214 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/214)
* Update doi in README [PR #165 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/165)
* Generalize the changelog generator [PR #215 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/215)
* Allow OpenMPI to oversubscribe on GitLab CI [PR #203 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/203)
* Add benchmark command to build_gs2 script [PR #155 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/155)
* Tidy makefile and remove old targets [PR #161 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/161)
* Bug fix: default to reproducible runs [PR #164 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/164)
* Bug fix: update release detection [PR #160 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/160)
* Update next to 8.0.2 [PR #159 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/159)


## 8.0.2 (2019-06-10)

* 8.0.2-RC [PR #135 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/135)
* Avoid the calculation of omega in nonlinear simulations with the new diagnostics module [PR #158 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/158)
* Prevents a large number of blank lines in the benchmark output [PR #157 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/157)
* Small tweak to avoid limitation in some ifort versions [PR #156 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/156)
* Ensure only proc0 tries to write information from overrides [PR #154 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/154)
* Make sure source code for generated overrides contains bug fix from PR #105 [PR #153 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/153)
* Add pfunit tests and documentation for leq [PR #150 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/150)
* Ensure failing tests are reported on gitlab [PR #145 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/145)
* Add pFUnit as a submodule; Run pfunit_tests on gitlab CI [PR #151 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/151)
* Remove old/unused scripts [PR #147 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/147)
* Bug fix to correctly count twist-and-shift links with shat<0 [PR #149 | Nicolas Christen](https://bitbucket.org/gyrokinetics/gs2/pull-requests/149)
* Update JFRS and Cray Makefiles [PR #146 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/146)
* Bug fix: fix geometry warnings various bugs [PR #143 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/143)
* Remove include statements where not required. [PR #144 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/144)
* Ensure the Makefile.local overrides are loaded early in parsing the Makefile. [PR #142 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/142)
* Set default values for two more inputs [PR #141 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/141)
* Bugfix: set default values of some inputs [PR #140 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/140)
* Add link to libgs2 to avoid undefined symbols [PR #139 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/139)
* Fix link for Jenkins badge in README [PR #137 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/137)
* Update CITATION.cff for 8.0.2 [PR #136 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/136)
* Update to latest version of Makefiles and utils [PR #134 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/134)
* Delete gryfx test [PR #133 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/133)
* Make generated source file match generator [PR #127 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/127)
* Remove non-optimised init_connected_bc routine and deprecate opt_init_bc [PR #129 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/129)
* Fix typo introduced by automated change [PR #130 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/130)
* Move programs to program folder [PR #128 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/128)
* Rearrange directory structure [PR #126 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/126)
* Add partial changelog for 8.0.2 [PR #125 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/125)
* Bugfix/ensure restart file includes explicit source [PR #114 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/114)
* Bugfix/port changes to init connected bc opt [PR #122 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/122)
* Enable use of pfunit 4 [PR #121 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/121)
* Improve README [PR #99 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/99)
* Remove Absoft compatibility SFX-related flags [PR #111 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/111)
* Add Jenkins tests for mac-osx [PR #117 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/117)
* Smarten up website landing page [PR #119 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/119)
* Fix bug with order of pfunit build rules [PR #110 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/110)
* Add FPPFLAGS to set cpp specific options [PR #116 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/116)
* Feature/add one step pp gitlab [PR #118 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/118)
* Bugfix/avoid calling user functions with no argument makefile [PR #115 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/115)
* Move test functions from main source to unit tests [PR #93 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/93)
* Fix address sanitizer in the coverage test [PR #113 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/113)
* Bugfix for nonlinear simulations with immediate_reset=.true. [PR #107 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/107)
* Run address sanitizer as part of Jenkins coverage tests [PR #88 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/88)
* Fix segfault which occurred when [PR #105 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/105)
* Ensure we pass MACRO_DEFS when compiling c files [PR #106 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/106)
* Report tests as skipped when TESTNORUN set [PR #101 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/101)
* Micro/add nl refactoring [PR #104 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/104)
* Tweak makefile to remove non-existent Include directories [PR #103 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/103)
* Use brackets to ensure array operation only done once [PR #102 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/102)
* Don't delete benchmark timing files in CLEANCOMMAND [PR #100 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/100)
* pFUnit tests [PR #85 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/85)
* Feature/gitlab more tests [PR #95 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/95)
* Do not vary nproc in gs2_optimization test [PR #86 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/86)
* Bugfix/job manage test more robust [PR #96 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/96)
* Update utils to include precomputing nrecv/nsend in redistributes [PR #94 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/94)
* Small tweak to avoid `make depend` generating the dependency file twice [PR #90 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/90)
* Get gitlab to build and host sourcecode documentation (built on #89) [PR #91 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/91)
* Add a benchmark for the fields_local field solve [PR #79 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/79)
* Say what the current timestep is when mentioning what we're changing it to [PR #87 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/87)
* Stop Tracking Makefile.depend [PR #75 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/75)
* Put repeated logic operation in subroutine [PR #37 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/37)
* Remove reference to unused macro USE_LE_LAYOUT [PR #81 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/81)
* Provide yaml file for use with gitlab CI [PR #71 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/71)
* Try to tidy some of the existing documentation and add placeholder text for missing entries [PR #80 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/80)
* Make job_manage available cpu time test more robust [PR #84 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/84)
* Add SCARF makefile [PR #82 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/82)
* Prettier building [PR #76 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/76)
* Update utils to latest next [PR #78 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/78)
* Add scripts for creating change logs [PR #67 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/67)
* Silence lots of warnings during make [PR #72 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/72)
* Use le_layout for collisions by default [PR #3 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/3)
* Add coverage tests [PR #73 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/73)
* Automated Jenkins testing [PR #30 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/30)


## v8.0.1 (2019-02-05)

* Add CHANGELOG.md for v8.0.1, remove README_RELEASE and STATUS files [PR #63 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/63)
* Update Makefiles and utils for v8.0.1 [PR #64 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/64)
* Add empty RELEASE file [PR #69 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/69)
* Remove explicit location from GK_SYSTEM [PR #68 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/68)
* Update CITATION.cff [PR #51 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/51)
* Add an option of build_gs2 to choose MPI procs [PR #65 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/65)
* Remove SEDSYSTEMCONFIG from Makefile [PR #66 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/66)
* Turn off expensive diagnostics by default [PR #36 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/36)
* Skip gf fields cyclone itg linear test if using too few processors [PR #60 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/60)
* Remove deprecation notice in gs2_diagnostics [PR #50 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/50)
* Adds special case to ei_coll_only handling for const_v=T [PR #55 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/55)
* Fix compile errors with Cray compilers [PR #62 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/62)
* Fix several unit_tests with Fujitsu compilers [PR #61 | Ryusuke Numata](https://bitbucket.org/gyrokinetics/gs2/pull-requests/61)
* Try to mirror original diagnostic treatment of nsave [PR #58 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/58)
* Fix theta_grid test with Cray compilers [PR #59 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/59)
* Update utils to inlude file_utils bugfix [PR #56 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/56)
* Fix automagic checkout of submodules [PR #49 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/49)
* Fix text colours in test output [PR #54 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/54)
* Update 8.0.1-RC to include constant_random bugfix for fujitsu compilers [PR #52 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/52)
* Tidy up gitignore and distclean for tests [PR #53 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/53)
* Set RUN_GCOV=off as default to prevent warning with build_gs2 [PR #48 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/48)
* Fix job manage test [PR #47 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/47)
* Skip some tests when building without libraries [PR #43 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/43)
* Update test_make [PR #44 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/44)
* Add citation file format file [PR #41 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/41)
* Prevent erroneous vectorization by gfortran 7.2 [PR #40 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/40)
* Fix conflicts in next to master merge [PR #39 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/39)
* Add redistribution benchmarks [PR #10 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/10)
* Update lowflow routines to use species-dependent energy and weights. [PR #33 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/33)
* Make test skipped messages more instructive [PR #35 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/35)
* Feature makefile tidyup [PR #17 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/17)
* Skip, not fail, the gf field test if fewer than 6 procs used [PR #32 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/32)
* Make master compatible with git [PR #27 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/27)
* Automatically init all submodules on make [PR #11 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/11)
* Delete collisions tests, which are a repeat of le_grids tests [PR #25 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/25)
* Contributing docs [PR #19 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/19)
* Track test coverage with Codecov [PR #31 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/31)
* Fixed variable assignment problem for variable SEDSYSTEMCONFIG in Makefile.  addresses #26 [PR #23 | Colin Malcolm Roach](https://bitbucket.org/gyrokinetics/gs2/pull-requests/23)
* Code coverage with gcov [PR #20 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/20)
* Fixed a bug where negrid was not set in calculate_f0_arrays_tabulated. [PR #24 | George Wilkie](https://bitbucket.org/gyrokinetics/gs2/pull-requests/24)
* Increase maximum pipeline time [PR #22 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/22)
* Automated testing [PR #12 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/12)
* Fix le_grid-dependent tests [PR #9 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/9)
* Adds initial setup for using Ford documentation tool. [PR #18 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/18)
* Replace svn with git [PR #7 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/7)
* Add more patterns to gitignore [PR #16 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/16)
* Update utils submodule to current master [PR #15 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/15)
* Some README tidying [PR #14 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/14)
* Feature submodules for externals [PR #6 | David Dickinson](https://bitbucket.org/gyrokinetics/gs2/pull-requests/6)
* Fix dump_grids build [PR #1 | Joseph Parker](https://bitbucket.org/gyrokinetics/gs2/pull-requests/1)
* Add Gitignore [PR #13 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/13)
* Add more patterns to gitignore [PR #4 | Peter Hill](https://bitbucket.org/gyrokinetics/gs2/pull-requests/4)
* Remove trailing bracket that causes compile error [PR #5 | Stephen Biggs-Fox](https://bitbucket.org/gyrokinetics/gs2/pull-requests/5)
